JMS to IMS via WMQ

John B Jones, BSc, MSc, MIEE, CEng
IBM Hursley (UK)	c IBM 2003  



   LLZZ<tcode><data>


   00000000:  C9C9 C840 0000 0001 0000 0054 0000 0311 'IIH ............'
   00000010:  0000 01F4 D4D8 C9D4 E2E5 E240 0000 0000 '...4MQIMSVS ....'
   00000020:  4040 4040 4040 4040 4040 4040 4040 4040 '                '
   00000030:  D4D8 C9D4 E2E5 E240 D4C1 E3E3 C8F3 E6E2 'MQIMSVS         '
   00000040:  0000 0000 0000 0000 0000 0000 0000 0000 '................'
   00000050:  40F0 C340 0012 0000 61C4 C9E2 40D7 D6D6 ' 0C ..../DIS POO'
   00000060:  D340 D3E4 D4D7                          'L LUMP          '


   00000000:  4949 4820 0100 0000 5400 0000 2202 0000 'IIH ....T..."...'
   00000010:  B804 0000 4D51 494D 5356 5320 0000 0000 ',...MQIMSVS ....'
   00000020:  2020 2020 2020 2020 2020 2020 2020 2020 '                '
   00000030:  4D51 494D 5356 5320 2020 2020 2020 2020 'MQIMSVS         '
   00000040:  0000 0000 0000 0000 0000 0000 0000 0000 '................'
   00000050:  2030 4320 1200 0000 2F44 4953 2050 4F4F ' 0C ..../DIS POO'
   00000060:  4C20 4C55 4D50                          'L LUMP          '  


   // Set the Queue Manager and Queue names to be used
   //    queue manager will be used
   private final String QUEUE_MANAGER = " ";


   // Set bindings mode and define the queue manager to use
   factory.setTransportType(JMSC.MQJMS_TP_BINDINGS_MQ);
   factory.setQueueManager(QUEUE_MANAGER);


   // queue.targetClient must be set to JMSC.MQJMS_CLIENT_NONJMS_MQ
   // as the target client is WMQ and not a JMS application.
   //   This causes the message to be produced without an MQRFH2 
   //   header and thus be suitable for use by a non-JMS program
   queue.setTargetClient(JMSC.MQJMS_CLIENT_NONJMS_MQ);


catch (JMSException je) {
      System.out.println("Exception in JMStoIMSviaWMQ: " +je);
      Exception e = je.getLinkedException();
      if (e != null) {
        System.out.println("linked exception: "+e);          
      }


   Exception in JMStoIMSviaWMQ: javax.jms.JMSException: MQJMS2005: 


   linked exception: com.ibm.mq.MQException:  MQJE001: Completion Code 


//* Module Name      : JMStoIMSviaWMQ
//* Environment      : JMS with WebSphere MQ as transport layer
//* Description      : This program shows how to construct a message
//*                    which will be used by a non-JMS consumer.
//*                    The consumer in this example is IMS accessed
//*                    through the MQ-IMS Bridge.
//*                    Alter the QUEUE_MANAGER and QUEUE attributes
//*                    before using.  As written it will use the
//*                    default WebSphere MQ Queue Manager,
//*                    a queue "Q1", and a reply queue "Q1_REPLY"
//* Limitations      : This program was tested with WebSphere MQ V5.3
//* Function         : This program takes no parameters and produces
//*                    a message which if sent via WMQ to IMS
//*                    executes the IMS /DIS POOL LUMP command.
import java.util.*;
import java.lang.Exception;
import javax.jms.*;
import javax.naming.*;
import com.ibm.mq.jms.*;
public class JMStoIMSviaWMQ {
  private BytesMessage message = null;
  // Set the Queue Manager and Queue names to be used
  //    If the lines below are unchanged, queues Q1 and Q1_REPLY
  //    on the default queue manager will be used
  private final String QUEUE_MANAGER = "";
  private final String QUEUE = "Q1";
  private final String REPLY_TO = "Q1_REPLY";
  // Define constants to hold the values to be used
  // in the fields of the MQMD and MQIIH in the message
  private String strucID =       "IIH ";
  private int version =          1;
  private int strucLength =      84;
  private int encoding =         546;
  private int codedCharSetID =   1208;
  private String format =        "MQIMSVS ";
  private int flags =            0;
  private String lTermOverride = "        ";
  private String mfsMapName =    "        ";
  private String replyToFormat = "MQIMSVS ";
  private String authenticator = "        ";
  private byte[] tranInstanceID = new byte[16];
  private String tranState =     " ";
  private String commitMode =    "0";
  private String securityScope = "C";
  private String reserved =      " ";
  // Define the content of the message body
  public String content = "/DIS POOL LUMP";
  public static void main(String[] args) {
    JMStoIMSviaWMQ PutMessage = new JMStoIMSviaWMQ();
    PutMessage.go();
  }
  //*
  //* Constructor
  //*
  JMStoIMSviaWMQ() {
    super();
  }
  //*
  //*  Set up the necessary JMS objects, build and send the message
  //*
  private void go() {
    try {
      MQQueueConnectionFactory factory = null;
      MQQueue queue = null;
      MQQueue replyToQueue = null;
      QueueConnection connection = null;
      QueueSession session = null;
      QueueSender sender = null;
      System.out.println("Creating a QueueConnectionFactory");
      factory = new MQQueueConnectionFactory();
      // Set bindings mode and define the queue manager to use
      factory.setTransportType(JMSC.MQJMS_TP_BINDINGS_MQ);
      factory.setQueueManager(QUEUE_MANAGER);
      System.out.println("Creating a QueueConnection");
      connection = factory.createQueueConnection();
      System.out.println("Starting the connection");
      connection.start();
      System.out.println("Creating QueueSession");
      boolean transacted = false;
      int acknowledgeMode = Session.AUTO_ACKNOWLEDGE;
      session = connection.createQueueSession(transacted, 


      System.out.println("Creating ReplyTo Queue");
      replyToQueue = new MQQueue("",REPLY_TO);
      System.out.println("Creating Queue");
      queue = new MQQueue();
      queue.setBaseQueueName(QUEUE);
      queue.setPersistence(DeliveryMode.NON_PERSISTENT);
      // queue.targetClient must be set to JMSC.MQJMS_CLIENT_NONJMS_MQ
      // as the target client is WMQ and not a JMS application.
      //   This causes the message to be produced without an MQRFH2 


      //   and thus be suitable for use by a non-JMS program
      queue.setTargetClient(JMSC.MQJMS_CLIENT_NONJMS_MQ);
      // Set the Encoding and CodedCharSetId in the MQMD
      queue.setEncoding(encoding);
      queue.setCCSID(codedCharSetID);
      System.out.println("Creating QueueSender");
      sender = session.createSender(queue);
      System.out.println("Creating BytesMessage");
      message = session.createBytesMessage();
      // Set the Format and ReplyToQ in the MQMD
      message.setStringProperty("JMS_IBM_Format","MQIMS   ");
      message.setJMSReplyTo(replyToQueue);
      // Write the output message
      //   Data appears in the message in the order it is written.
      //   buildMessage writes all the data into the message,
      //   it assumes that the values have been set prior to it being
      //   invoked - this is done using constants in this example
      System.out.println("Building BytesMessage");
      buildMessage();
      System.out.println("Sending BytesMessage");
      sender.send(message);
      System.out.println("Closing objects");
      sender.close();
      session.close();
      connection.close();
      System.out.println("Finished");
    }
    catch (JMSException je) {
      System.out.println("Exception in JMStoIMSviaWMQ: " +je);
      Exception e = je.getLinkedException();
      if (e != null) {
        System.out.println("linked exception: "+e);
      }
    }
  }
  //*
  //* Build the message to put onto the queue
  //*   - The message is built using BytesMessage; this message
  //*     type is for encoding a body to match an existing message
  //*     format. Fields are added to the message in the order in
  //*     which they appear.
  //*
  private void buildMessage() {
    buildHeader();
    buildBody();
  }
  //*
  //* Build the MQIIH with the defined value
  //*
  //*   The C declaration of the MQIIH structure is:
  //* typedef struct tagMQIIH MQIIH;
  //* struct tagMQIIH {
  //*   MQCHAR4   StrucId;         /* Structure identifier */
  //*   MQLONG    Version;         /* Structure version number */
  //*   MQLONG    StrucLength;     /* Length of MQIIH structure */
  //*   MQLONG    Encoding;        /* Reserved */
  //*   MQLONG    CodedCharSetId;  /* Reserved */
  //*   MQCHAR8   Format;          /* MQ format name of data that 


  //*                                 MQIIH */
  //*   MQLONG    Flags;           /* Flags */
  //*   MQCHAR8   LTermOverride;   /* Logical terminal override */
  //*   MQCHAR8   MFSMapName;      /* Message format services map name */
  //*   MQCHAR8   ReplyToFormat;   /* MQ format name of reply message */
  //*   MQCHAR8   Authenticator;   /* RACF password or passticket */
  //*   MQBYTE16  TranInstanceId;  /* Transaction instance identifier */
  //*   MQCHAR    TranState;       /* Transaction state */
  //*   MQCHAR    CommitMode;      /* Commit mode */
  //*   MQCHAR    SecurityScope;   /* Security scope */
  //*   MQCHAR    Reserved;        /* Reserved */
  //* };
  //*
private void buildHeader() {
    try {
      addChars(strucID);
      message.writeInt(version);
      message.writeInt(strucLength);
      message.writeInt(encoding);
      message.writeInt(codedCharSetID);
      addChars(format);
      message.writeInt(flags);
      addChars(lTermOverride);
      addChars(mfsMapName);
      addChars(replyToFormat);
      addChars(authenticator);
      message.writeBytes(tranInstanceID);
      addChars(tranState);
      addChars(commitMode);
      addChars(securityScope);
      addChars(reserved);
    } catch(JMSException je) {
      System.out.println("Exception in buildHeader: " +je);
      Exception e = je.getLinkedException();
      if (e != null) {
        System.out.println("linked exception: "+e);
      }
    }
  }
  //*
  //* Build up the body of the text using the content specified
  //*  A message to be sent into IMS has a format LLZZ<data> where:
  //*  - LL is a two byte integer defining the length of the message
  //*    segment
  //*  - ZZ is two flag bytes set to NULL
  //*  - <data> is the application data structure being sent into IMS
  //*    (in this case it is in variable 'content')
  //*
  private void buildBody() {
    try {
      // Find the length of the body section + LLZZ
      short bodyLength = (short)(content.length() + 4);
      // Two bytes to represent the length of the body
      message.writeShort(bodyLength);
      // Two null bytes
      message.writeShort((short)0);
      // Add the message content
      addChars(content);
    } catch(JMSException je) {
      System.out.println("Exception in buildBody: " +je);
      Exception e = je.getLinkedException();
      if (e != null) {
        System.out.println("linked exception: "+e);
      }
    }
  }
  //* Add a String to the message, character by character
  //*
  private void addChars(String chars) {
    try {
        byte[] b = chars.getBytes();
        message.writeBytes(b);
    } catch(JMSException je) {
      System.out.println("Exception in addChars: " +je);
      Exception e = je.getLinkedException();
      if (e != null) {
        System.out.println("linked exception: "+e);
      }
    }
  }
}


/*  MQIIH Structure -- IMS Interface Header                          */
 typedef struct tagMQIIH {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQLONG    StrucLength;     /* Length of MQIIH structure */
   MQLONG    Encoding;        /* Reserved */
   MQLONG    CodedCharSetId;  /* Reserved */
   MQCHAR8   Format;          /* MQ Format name */
   MQLONG    Flags;           /* Reserved */
   MQCHAR8   LTermOverride;   /* Logical terminal override */
   MQCHAR8   MFSMapName;      /* Message format services map name */
   MQCHAR8   ReplyToFormat;   /* MQ Format name of reply message */
   MQCHAR8   Authenticator;   /* RACF password or pass ticket */
   MQBYTE16  TranInstanceId;  /* Transaction instance id */
   MQCHAR    TranState;       /* Transaction state */
   MQCHAR    CommitMode;      /* Commit mode */
   MQCHAR    SecurityScope;   /* Security scope */
   MQCHAR    Reserved;        /* Reserved */
  } MQIIH;


****Message descriptor****
  StrucId  : 'MD  '  Version : 2
  Report   : 0  MsgType : 1
  Expiry   : -1  Feedback : 0
  Encoding : 546  CodedCharSetId : 1208
  Format : 'MQIMS   '
  Priority : 4  Persistence : 0
  MsgId : X'414D5120514D5F6A6F686E20202020202E63913D20000201'
  CorrelId : X'000000000000000000000000000000000000000000000000'
  BackoutCount : 0
  ReplyToQ       : 'Q1_REPLY                                        '
  ReplyToQMgr    : 'JOHNJ                                           '
  ** Identity Context
  UserIdentifier : 'johnj       '
  AccountingToken :
   X'16010515000000B72EEA1114086F4A3A37067FF401000000000000000000000B'
  ApplIdentityData : '                                '
  ** Origin Context
  PutApplType    : '11'
  PutApplName    : 'C:\WINNT\SYSTEM32\java.exe  '
  PutDate  : '20020925'    PutTime  : '08030555'
  ApplOriginData : '    '
  GroupId : X'000000000000000000000000000000000000000000000000'
  MsgSeqNumber   : '1'
  Offset         : '0'
  MsgFlags       : '0'
  OriginalLength : '-1'
****   Message      ****
 length - 102 bytes
00000000:  4949 4820 0100 0000 5400 0000 2202 0000 'IIH ....T..."...'
00000010:  B804 0000 4D51 494D 5356 5320 0000 0000 ',...MQIMSVS ....'
00000020:  2020 2020 2020 2020 2020 2020 2020 2020 '                '
00000030:  4D51 494D 5356 5320 2020 2020 2020 2020 'MQIMSVS         '
00000040:  0000 0000 0000 0000 0000 0000 0000 0000 '................'
00000050:  2030 4320 1200 0000 2F44 4953 2050 4F4F ' 0C ..../DIS POO'
00000060:  4C20 4C55 4D50                          'L LUMP          '  


****Message descriptor****
  StrucId  : 'MD  '  Version : 1
  Report   : 0  MsgType : 1
  Expiry   : -1  Feedback : 0
  Encoding : 785  CodedCharSetId : 500
  Format : 'MQIMS   '
  Priority : 4  Persistence : 0
  MsgId : X'414D51204A4F484E4A202020202020203D6C903D20001201'
  CorrelId : X'000000000000000000000000000000000000000000000000'
  BackoutCount : 0
  ReplyToQ       : 'Q1_REPLY                                        '
  ReplyToQMgr    : 'JOHNJ                                           '
  ** Identity Context
  UserIdentifier : 'JOHNJ       '
  AccountingToken :
   X'16010515000000B72EEA1114086F4A3A37067FF401000000000000000000000B'
  ApplIdentityData : '                                '
  ** Origin Context
  PutApplType    : '11'
  PutApplName    : 'C:\WINNT\SYSTEM32\java.exe  '
  PutDate  : '20020924'    PutTime  : '15271673'
  ApplOriginData : '    '
****   Message      ****
 length - 101 bytes
00000000:  C9C9 C840 0000 0001 0000 0054 0000 0311 'IIH ............'
00000010:  0000 01F4 D4D8 C9D4 E2E5 E240 0000 0000 '...4MQIMSVS ....'
00000020:  4040 4040 4040 4040 4040 4040 4040 4040 '                '
00000030:  D4D8 C9D4 E2E5 E240 D4C1 E3E3 C8F3 E6E2 'MQIMSVS         '
00000040:  0000 0000 0000 0000 0000 0000 0000 0000 '................'
00000050:  40F0 C340 0011 0000 61C4 C9E2 40D7 D6D6 ' 0C ..../DIS POO'
00000060:  D340 D3E4 D4D7                          'L LUMP          '


****Message descriptor****
  StrucId  : 'MD  '  Version : 2
  Report   : 0  MsgType : 2
  Expiry   : -1  Feedback : 0
  Encoding : 785  CodedCharSetId : 500
  Format : 'MQIMS   '
  Priority : 4  Persistence : 1
  MsgId : X'C3E2D840D4D8F3F54040404040404040B8476EC063D71285'
  CorrelId : X'414D51204A4F484E4A202020202020203D6C903D20001A01'
  BackoutCount : 0
  ReplyToQ       : '                                                '
  ReplyToQMgr    : 'MQ35                                            '
  ** Identity Context
  UserIdentifier : 'johnj       '
  AccountingToken :
   X'16010515000000B72EEA1114086F4A3A37067FF401000000000000000000000B'
  ApplIdentityData : '                                '
  ** Origin Context
  PutApplType    : '20'
  PutApplName    : 'PROTOGRPIYEAZI6A            '
  PutDate  : '20020924'    PutTime  : '15440465'
  ApplOriginData : '    '
  GroupId : X'000000000000000000000000000000000000000000000000'
  MsgSeqNumber   : '1'
  Offset         : '0'
  MsgFlags       : '0'
  OriginalLength : '-1'
****   Message      ****
 length - 196 bytes
00000000:  C9C9 C840 0000 0001 0000 0054 0000 0311 'E@.......T....'
00000010:  0000 0000 D4D8 C9D4 E2E5 E240 0000 0000 '....O0O@....'
00000020:  4040 4040 4040 4040 C4C6 E2C4 E2D7 D6F1 '@@@@@@@@'
00000030:  4040 4040 4040 4040 4040 4040 4040 4040 '@@@@@@@@@@@@@@@@'
00000040:  0000 0000 0000 0000 0000 0000 0000 0000 '................'
00000050:  40F0 4040 0017 1B00 15D3 E4D4 D740 C2E4 '@?@@.....OO@A'
00000060:  C6C6 C5D9 40D7 D6D6 D37A 1500 451B 0040 'U@Oz..E..@'
00000070:  E2C9 E9C5 4040 4040 40F1 F3F4 D240 40C8 '@@@@@O@@E'
00000080:  C9C7 C840 4040 4040 F2F0 F8D2 4040 D3C9 'E@@@@@?oO@@O'
00000090:  D4C9 E340 4040 4040 D5D6 D5C5 4040 D6E5 'Oa@@@@@OO@@'
000000A0:  C5D9 C6D3 D6E6 4040 4040 4040 40F0 D215 'UO@@@@@@@?O.'
000000B0:  0014 1B00 155C F0F2 F2F6 F761 F1F6 F4F3 '.....\?a'
000000C0:  F4F4 5C15                               '\.           '    


****Message descriptor****
  StrucId  : 'MD  '  Version : 2
  Report   : 0  MsgType : 2
  Expiry   : -1  Feedback : 0
  Encoding : 546  CodedCharSetId : 437
  Format : 'MQIMS   '
  Priority : 4  Persistence : 1
  MsgId : X'C3E2D840D4D8F3F54040404040404040B8476EC063D71285'
  CorrelId : X'414D51204A4F484E4A202020202020203D6C903D20001A01'
  BackoutCount : 0
  ReplyToQ       : '                                                '
  ReplyToQMgr    : 'MQ35                                            '
  ** Identity Context
  UserIdentifier : 'johnj       '
  AccountingToken :
   X'16010515000000B72EEA1114086F4A3A37067FF401000000000000000000000B'
  ApplIdentityData : '                                '
  ** Origin Context
  PutApplType    : '20'
  PutApplName    : 'PROTOGRPIYEAZI6A            '
  PutDate  : '20020924'    PutTime  : '15440465'
  ApplOriginData : '    '
  GroupId : X'000000000000000000000000000000000000000000000000'
  MsgSeqNumber   : '1'
  Offset         : '0'
  MsgFlags       : '0'
  OriginalLength : '-1'
****   Message      ****
 length - 196 bytes
00000000:  4949 4820 0100 0000 5400 0000 1103 0000 'IIH ....T.......'
00000010:  0000 0000 4D51 494D 5356 5320 0000 0000 '....MQIMSVS ....'
00000020:  2020 2020 2020 2020 4446 5344 5350 4F31 '        DFSDSPO1'
00000030:  2020 2020 2020 2020 2020 2020 2020 2020 '                '
00000040:  0000 0000 0000 0000 0000 0000 0000 0000 '................'
00000050:  2030 2020 1700 1B00 0A4C 554D 5020 4255 ' 0  .....LUMP BU'
00000060:  4646 4552 2050 4F4F 4C3A 0A45 001B 0020 'FFER POOL:.E... '
00000070:  5349 5A45 2020 2020 2031 3334 4B20 2048 'SIZE     134K  H'
00000080:  4947 4820 2020 2020 3230 384B 2020 4C49 'IGH     208K  LI'
00000090:  4D49 5420 2020 2020 4E4F 4E45 2020 4F56 'MIT     NONE  OV'
000000A0:  4552 464C 4F57 2020 2020 2020 2030 4B0A 'ERFLOW       0K.'
000000B0:  1400 1B00 0A2A 3032 3236 372F 3136 3433 '.....*02267/1643'
000000C0:  3434 2A0A                               '44*.           '

